if RequiredScript == "lib/units/weapons/weaponlaser" then
 
        local init_original = WeaponLaser.init
 
        WeaponLaser.DEFINITIONS = {
                player = {      --Player
                        color = Color(0, 0.1, 1),
                        alpha = 0.25,
                },
                cop_sniper = {  --Enemy snipers
                        color = Color(0.7, 0, 0),
                        alpha = 0.5,
                },
                default = {     --Team mates
                        color = Color(0, 0.1, 1),
                        alpha = 0.25,
                },
                turret_module_active = {        --SWAT turret standard
                        color = Color(1, 0, 0),
                        alpha = 0.15,
                },
                turret_module_rearming = {      --SWAT turret reloading
                        color = Color(1, 1, 0),
                        alpha = 0.11,
                },
                turret_module_mad = {   --SWAT turret jammed
                        color = Color(0, 1, 0),
                        alpha = 0.15,
                },
        }
       
        function WeaponLaser:init(...)
                init_original(self, ...)
                self:init_themes()
				self:set_color_by_theme(self._theme_type)

        end
       
        function WeaponLaser:init_themes()
                for theme, data in pairs(WeaponLaser.DEFINITIONS) do
                        self:update_theme(theme, data.color, data.alpha)
                end
        end
 
        function WeaponLaser:update_theme(name, color, alpha)
                self._themes[name] = self._themes[name] or {}
                local color = color or self._themes[name].brush or Color.white
                local alpha = alpha or self._themes[name].brush and self._themes[name].brush.alpha or 0
 
                self._themes[name] = {
                        light = color * 10,
                        glow = color / 5,
                        brush = color:with_alpha(alpha)
                }
        end
 
elseif RequiredScript == "lib/units/weapons/raycastweaponbase" then
 
        local on_equip_original = RaycastWeaponBase.on_equip
 
        function RaycastWeaponBase:on_equip(...)
                if self._has_gadget then
                        self:_setup_laser()
                        if alive(self._second_gun) then
                                self._second_gun:base():_setup_laser()
                        end
                end
               
                return on_equip_original(self, ...)
        end
       
        function RaycastWeaponBase:_setup_laser()
                for id, part in pairs(self._parts) do
                        local base = part.unit and part.unit:base()
                        if base and base.set_color_by_theme then
                                base:set_color_by_theme("player")
                        end
                end
        end
       
end